#!/bin/sh
process(){
	while read a b
	do
		if [ "$a" = "***" ] ; then
			a=$b
		fi
		name=`basename $a .help`
		dir=`dirname $a`
		dir=`basename $dir`
		# Make sure this module/directory is part of linuxconf
		# not an externally built module
		if [ -d ../modules/$dir -o -d ../$dir ] ; then
			echo $dir $name
			mkdir -p sources/$dir
			echo $name >>sources/$dir/FILE_LIST
		fi
	done
	cd sources/notices
	for fi in *.sgml
	do
		basename $fi .sgml >>FILE_LIST
	done
	cd ../..
}
if [ $# != 1 ] ; then
	echo
	echo Build the list of help files for each subdirectory
	echo
	echo Called from help.files/Makefile with the command
	echo make list
	echo
elif [ ! -f scripts/build_list.sh ] ; then
	echo
	echo Must be executed from the help.files directory
	echo
elif [ ! -f /bin/linuxconf ] ; then
	echo
	echo Linuxconf must be installed before using this script
	echo
elif [ "$1" = "ok" ] ; then
	rm -f sources/*/FILE_LIST
	process
fi

