#include <stdio.h>
#include <errno.h>
#include <unistd.h>
/*#include <sys/uio.h>*/
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <sys/socket.h>
#include <sys/un.h>

int manager_client (const char *sockn)
{
	int ret = -1;
	int fd =  socket (AF_UNIX,SOCK_STREAM,0);
	if (fd == -1){
		perror("socket client");
	}else{
		struct sockaddr_un un;
		un.sun_family = AF_UNIX;
		strcpy (un.sun_path,sockn);
		int pid = getpid();
		fcntl (fd,F_SETOWN,(void*)pid);
		int s = connect(fd,(struct sockaddr*)&un,sizeof(un));
		if (s == -1){
			perror("connect");
		}else{
			ret = fd;
		}
	}
	return ret;
}

int manager_server(const char *sockn)
{
	int ret = -1;
	unlink (sockn);
	int fd =  socket (AF_UNIX,SOCK_STREAM,0);
	if (fd == -1){
		perror("socket server");
	}else{
		struct sockaddr_un un;
		un.sun_family = AF_UNIX;
		strcpy (un.sun_path,sockn);
		if (bind(fd,(struct sockaddr*)&un,sizeof(un))==-1){
			perror("bind");
		}else{
			chmod (sockn,0666);
			int code = listen (fd,10);
			if (code == -1){
				perror ("listen");
			}else{
				struct sockaddr_un unc;
				int len = sizeof(unc);
				unc.sun_family = AF_UNIX;
				int s = accept (fd,(struct sockaddr*)&unc,&len);
				if (s == -1){
					perror ("accept");
				}else{
					ret = s;
				}
			}	
		}
	}
	return ret;
}

static int manager_sendfd(int sock, int f0, int f1)
{
	char bufctl[sizeof(struct cmsghdr)+2*sizeof(int)];
	struct cmsghdr *c = (struct cmsghdr*)bufctl;
	c->cmsg_len = sizeof(bufctl);
	c->cmsg_level = SOL_SOCKET;
	c->cmsg_type = SCM_RIGHTS;
	int *fds = (int*)c->cmsg_data;
	fds[0] = f0;
	fds[1] = f1;

	struct msghdr h;

	struct iovec iov[1];
	char buf[1000];
	strcpy (buf,"hellohello");
	iov[0].iov_base = buf;
	iov[0].iov_len = 10;

	h.msg_name = 0;
	h.msg_namelen = 0;
	h.msg_iov = iov;
	h.msg_iovlen = 1;
	h.msg_control = (void*)bufctl;
	h.msg_controllen = sizeof(bufctl);
	h.msg_flags = 0;
	int ret = sendmsg (sock,&h,0);
	if (ret==-1){
		perror ("sendmsg");
	}
	return ret;
}


int main (int argc, char *argv[])
{
	int ret = -1;
	if (argc == 2){
		static const char sockn[]="/tmp/test.s";
		if (strcmp(argv[1],"client")==0){
			int fd = manager_client(sockn);
			if (fd != -1){
				manager_sendfd (fd,0,1);
				#if 1
					for (int i=0; i<10; i++){
						char buf[10];
						printf ("<enter> "); fflush (stdout);
						fgets (buf,sizeof(buf)-1,stdin);
						write (fd,"hello",5);
					}
				#endif
			}
		}else if (strcmp(argv[1],"server")==0){
			int fd = manager_server(sockn);
			if (fd != -1){
				printf ("Connect ok\n");
				while (1){
					char bufctl[sizeof(struct cmsghdr)+20*sizeof(int)];
					struct iovec iov[1];
					char buf[1000];
					iov[0].iov_base = buf;
					iov[0].iov_len = sizeof(buf);
					struct msghdr h;
					h.msg_name = 0;
					h.msg_namelen = 0;
					h.msg_iov = iov;
					h.msg_iovlen = 1;
					h.msg_control = bufctl;
					h.msg_controllen = sizeof(bufctl);
					h.msg_flags = 0;
					int len = recvmsg (fd,&h,0);
					if (len==-1){
						perror ("recvmsg");
						break;
					}else{
						struct cmsghdr *c = (struct cmsghdr*) bufctl;
						printf ("message recu flags %d len %d %d %u\n"
							,h.msg_flags,len
							,h.msg_controllen,sizeof(bufctl));
						if (c->cmsg_level == SOL_SOCKET
							&& c->cmsg_type == SCM_RIGHTS){
							printf ("fd passing\n");
						}
					}
				}
				#if 0
					printf ("getown %d\n",fcntl(fd,F_GETOWN,0));
					int n;
					char buf[1000];
					while ((n=read(fd,buf,sizeof(buf)-1))> 0){
						buf[n] = '\0';
						printf ("read %d :%s:\n",n,buf);
					}
					if (n == -1){
						perror ("read");
					}
				#endif
			}
		}
	}
	return ret;
}

