/* _dict.cc 14/08/96 14.39.06 */
/* array.cc 13/09/98 01.13.12 */
/* confdb.cc 17/09/98 11.57.32 */
/* configf.cc 09/01/99 21.50.22 */
void configf_required (void);
void configf_forgetpath (void);
const char *configf_lookuppath (const char *key);
void configf_sendexist (SSTREAM&ss, bool do_exist);
int file_type (const char *path);
bool file_exist (const char *path);
long file_date (const char *path);
int file_create (const char *path,
	 const char *owner,
	 const char *group,
	 int perm);
void configf_show (void);
int configf_getsubsyslist (SSTRINGS&tb);
void configf_booterase (void);
int configf_archive (const SSTRINGS&tb,
	 const char *command,
	 const char *arg,
	 SSTREAM&ssout,
	 bool verbose);
int configf_extract (const SSTRINGS&tb,
	 const char *command,
	 const char *arg);
int configf_md5sum (const SSTRINGS&tb, SSTREAM&ss);
CONFIG_FILE *configf_locate (const char *path);
/* context.cc 14/10/98 10.33.44 */
bool context_isroot (void);
void context_setabspath (const char *path, char abspath[]);
int context_mkdir (const char *dir,
	 const char *user,
	 const char *group,
	 int perm);
int context_create (const char *path,
	 const char *user,
	 const char *group,
	 int perm);
bool context_fexist (const char *path);
/* dictionary.cc 10/01/99 20.48.44 */
/* dir.cc 02/10/98 01.20.08 */
int dir_getlist (const char *path, SSTRINGS&lst);
int dir_getlist (const char *path, const char *ext, SSTRINGS&lst);
int dir_getlist_p (const char *fpath, SSTRINGS&lst);
/* error.cc 11/08/98 12.35.28 */
void error_setmode (bool batch);
void xconf_error (const char *msg, ...);
void xconf_notice (const char *msg, ...);
/* fgets.cc 20/07/98 22.57.24 */
char *fgets_strip (char *buf,
	 int sizebuf,
	 FILE *fin,
	 char contcar,
	 char comcar,
	 int *noline);
char *fgets_strip (char *buf, int sizebuf, FILE *fin, int *noline);
int fgets_cont (char *buf, int size, FILE *fin);
const char *fgets_comments (char buf[],
	 int size,
	 FILE *fin,
	 SSTRING&comments,
	 char comchar);
const char *fgets_comments (char buf[],
	 int size,
	 FILE *fin,
	 SSTRING&comments);
void comment_write (const SSTRING&str, FILE *fout, char comchar);
void comment_write (const SSTRING&str, FILE *fout);
/* fgets1.cc 13/12/96 23.39.36 */
char *fgets_strip (char *buf,
	 int sizebuf,
	 FILE *fin,
	 char contcar,
	 char comcar,
	 int *noline,
	 int *empty);
/* file.cc 01/12/97 01.48.28 */
int file_mkdir (const char *dir,
	 int uid,
	 int gid,
	 int mode,
	 const char *src);
int file_mkdir (const char *dir,
	 const char *user,
	 const char *group,
	 int perm);
int file_mkdirp (const char *dir, int uid, int gid, int mode);
int file_copy (const char *src, const char *dst);
int file_copytree (const char *src,
	 const char *dst,
	 int uid,
	 int gid,
	 int mode);
int file_followlink (const char *fpath, char *realpath);
/* fopen.cc 22/12/97 00.37.36 */
FILE *xconf_fopen (const char *fname, const char *mode);
/* fopen1.cc 30/07/98 02.03.12 */
void xconf_fopencfg_bypass (bool _bypass);
FILE *xconf_fopencfg (PRIVILEGE *priv,
	 const char *fname,
	 const char *mode);
/* fviews.cc 26/11/98 17.44.14 */
void fviews_required (void);
/* helpf.cc 18/08/98 13.56.58 */
void help_setlang (const char *_lang, const char *envvar);
void helpf_checkall (void);
/* ipnum.cc 23/02/98 18.33.12 */
void ipnum_ip2a (struct hostent *ent, char *buf);
void ipnum_ip2a (struct hostent *ent, SSTRING&ip);
void ipnum_ip2a (unsigned long ip, char *buf);
void ipnum_ip2a (struct netent *ent, char *buf);
void ipnum_ip2a (struct netent *ent, SSTRING&ip);
int ipnum_aip24 (const char *aip, int num4[4]);
unsigned long ipnum_aip2l (const char *aip);
bool ipnum_validip (const char *aip, bool ishost);
/* ipstuff.cc 31/07/97 00.29.50 */
/* linuxconf.cc 26/10/98 18.36.18 */
void linuxconf_sethook (CONFDB * (*fct)(CONFDB *));
CONFDB *linuxconf_getdb (void);
const char *linuxconf_getval (const char *prefix, const char *key);
const char *linuxconf_getval (const char *prefix,
	 const char *key,
	 const char *defval);
int linuxconf_getvalnum (const char *prefix,
	 const char *key,
	 int defval);
int linuxconf_getall (const char *prefix,
	 const char *key,
	 SSTRINGS&lst,
	 bool copy);
void linuxconf_removeall (const char *prefix, const char *key);
void linuxconf_forget (void);
int linuxconf_save (PRIVILEGE *priv);
int linuxconf_save (void);
void linuxconf_setcursys (const char *sys);
int linuxconf_archive (const char *subsys);
int linuxconf_md5sum (const char *subsys, SSTREAM&ss);
int linuxconf_extract (const char *subsys);
void linuxconf_add (const char *prefix,
	 const char *key,
	 const char *val);
void linuxconf_add (const char *prefix,
	 const char *key,
	 const SSTRING&val);
void linuxconf_add (const char *prefix, const char *key, int val);
void linuxconf_replace (const char *prefix,
	 const char *key,
	 const char *val);
void linuxconf_replace (const char *prefix, const char *key, char val);
void linuxconf_replace (const char *prefix, const char *key, int val);
void linuxconf_replace (const char *prefix, const char *key, long val);
void linuxconf_replace (const char *prefix,
	 const char *key,
	 const SSTRING&val);
void linuxconf_replace (const char *prefix,
	 const char *key,
	 const SSTRINGS&vals);
const char *linuxconf_getdistdir (void);
void linuxconf_fixdistdir (const char *templat, char *path);
int linuxconf_reloadif (void);
const char *linuxconf_getlangmanual (void);
const char *linuxconf_getlang (void);
void linuxconf_setlang (const char *lang);
int linuxconf_getlangmode (void);
void linuxconf_setlangmode (int mode);
int linuxconf_getguimode (void);
void linuxconf_setguimode (int mode);
int linuxconf_getcolormode (void);
void linuxconf_setcolormode (int mode);
int linuxconf_getprefixtrig (void);
void linuxconf_setprefixtrig (int trig);
void linuxconf_loadmsg (const char *prefix, const char *rev);
int distrib_getvalnum (const char *key, int defval);
const char *distrib_getval (const char *key);
bool distrib_isenhanced (void);
/* malloc.cc 14/08/96 14.40.26 */
void *malloc_err (int size);
char *strdup_err (const char *str);
/* misc.cc 09/12/98 00.00.26 */
void misc_required (void);
/* module.cc 10/01/99 00.22.38 */
void module_setmenu (DIALOG&dia, MENU_CONTEXT context);
void module_setmenu (DIALOG&dia, const char *menuid);
int module_probe (int state, int target);
int module_hint (const char *module);
int module_domenu (MENU_CONTEXT context, const char *key);
int module_domenu (const char *menuid, const char *key);
int module_fixperm (bool boottime, bool silentflag);
int module_execmain (int argc, char *argv[]);
int module_dohtml (const char *key);
int module_sendmessage (const char *msg,
	 int argc,
	 const char *argv[]);
void module_usage (SSTRINGS&tb);
int module_locate (const char *basepath, char *realpath);
void module_config (void);
void module_loadcheck (const char *path);
SSTRINGS *module_getlist (void);
void module_load (void);
void module_loaddistmod (void);
void module_setone (const char *path);
void module_unsetone (const char *path);
/* module_api.cc 07/12/98 23.57.00 */
void module_api_required (void);
void module_register_api (const char *apiname,
	 int version,
	 void * (*fctget)(),
	 void (*fctrelease)(void *));
void *module_get_api (const char *apiname,
	 int version,
	 const char *client);
void module_release_api (const char *apiname, void *api);
/* popen.cc 10/01/99 00.47.08 */
void popen_initsignal (void);
int popen_getloginuid (void);
/* sstream.cc 08/12/98 01.32.18 */
/* sstring.cc 28/10/98 23.19.42 */
/* sstrings.cc 11/09/98 17.11.26 */
/* str.cc 28/07/98 14.20.02 */
char *str_copyword (char *dest, const char *str);
char *str_copyword (char *dest, const char *str, int size);
int str_isword (const char *str, const char *word);
void strcpy_cut (char *dst, const char *src, int size);
char *str_skipword (const char *str);
char *str_copyword (SSTRING&dest, const char *str);
void tbstr_free (char *tb[], int nb);
int stricmp (const char *str1, const char *str2);
void strupr (char *str);
const char *str_extract (const char *buf, SSTRING&s);
int str_splitline (const char *line, char delim, SSTRINGS&words);
/* str1.cc 12/11/97 02.59.48 */
int str_strip (const char *str, char *newstr);
char *strip_end (char *str);
char *str_skip (const char *str);
char *str_skipdig (const char *str);
int str_checkdig (const char *str);
int str_splitline (const char *line,
	 char delim,
	 char words[][100],
	 int maxwords);
/* str3.cc 29/11/97 13.38.42 */
void str3_required (void);
char *str_copyquotec (char *dest,
	 const char *str,
	 char escape,
	 int compile);
char *str_copyquote (char *dest, const char *str);
/* str6.cc 29/11/97 13.38.50 */
void str6_required (void);
int str_exptab (const char *src, int step, char *dst);
/* subsys.cc 20/12/98 14.34.32 */
int subsys_getallsubsys (SSTRINGS&tb);
int subsys_getallsubsys (SSTRINGS&tb, SSTRINGS&titles);
const char *confver_getcur (void);
void confver_setcur (const char *newcur);
const char *confver_getfamily (const char *subsys);
bool confver_getmode (void);
void confver_edit (void);
void confver_selnewver (void);
int subsys_archive (void);
int subsys_archive (int nb, const char *tb[]);
int subsys_extract (void);
int subsys_extract (int nb, const char *tb[]);
int subsys_md5sum (int nb, const char *tb[]);
int subsys_diff (int nb, const char *tb[]);
int subsys_history (int nb, const char *tb[]);
/* timestr.cc 06/01/98 03.02.00 */
/* uname.cc 08/07/98 16.47.12 */
int kernel_version (int v[3]);
int kernel_newer (int v0, int v1, int v2);
long sys_uptime (void);
/* virtdb.cc 23/09/97 01.14.20 */
int virtdb_main (int argc, char *argv[]);
/* xconf1.cc 23/07/98 23.43.28 */
MENU_STATUS xconf_menu_gen (const char *title,
	 const char *explan,
	 HELP_FILE&helpfile,
	 int options,
	 const char *opt[],
	 int &choice);
MENU_STATUS xconf_menu (const char *title,
	 const char *explan,
	 HELP_FILE&helpfile,
	 const char *opt[],
	 int &choice);
MENU_STATUS xconf_menu (const char *title,
	 const char *explan,
	 const char *opt[],
	 int &choice);
MENU_STATUS xconf_menu (const char *title,
	 const char *explan,
	 HELP_FILE&helpfile,
	 const char *save_what,
	 const char *ins_what,
	 const char *del_what,
	 const char *add_what,
	 const char *opt[],
	 int &choice);
MENU_STATUS xconf_yesno (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile);
int xconf_quitwosave (void);
int xconf_areyousure (const char *msg);
int xconf_delok (void);
/* xconf2.cc 21/01/98 12.29.30 */
MENU_STATUS xconf_inputbox (const char *title,
	 const char *explan,
	 HELP_FILE&helpfile,
	 char buffer[MAX_LEN+1]);
MENU_STATUS xconf_inputpass (const char *title,
	 const char *explan,
	 HELP_FILE&helpfile,
	 char buffer[MAX_LEN+1]);
MENU_STATUS xconf_multiinp (const char *title,
	 const char *intro,
	 HELP_FILE&helpfile,
	 const char *prompts[],
	 char minstr[][MAX_LEN+1],
	 int nbfield,
	 int edit,
	 int nof);
int xconf_checklist (const char *title,
	 const char *prompt,
	 HELP_FILE&helpfile,
	 int list_height,
	 int item_no,
	 char **items,
	 char *status);
